//
//  Copyright (c) 2021 Open Whisper Systems. All rights reserved.
//

#import <SignalServiceKit/BaseModel.h>
#import <SignalServiceKit/StickerInfo.h>

NS_ASSUME_NONNULL_BEGIN

@class SDSAnyReadTransaction;

@interface KnownStickerPack : BaseModel

@property (nonatomic, readonly) StickerPackInfo *info;
@property (nonatomic) NSInteger referenceCount;
@property (nonatomic, readonly) NSDate *dateCreated;

+ (instancetype)new NS_UNAVAILABLE;
- (instancetype)init NS_UNAVAILABLE;
- (nullable instancetype)initWithCoder:(NSCoder *)coder NS_DESIGNATED_INITIALIZER;
- (instancetype)initWithUniqueId:(NSString *)uniqueId NS_UNAVAILABLE;
- (instancetype)initWithGrdbId:(int64_t)grdbId uniqueId:(NSString *)uniqueId NS_UNAVAILABLE;

- (instancetype)initWithInfo:(StickerPackInfo *)info NS_DESIGNATED_INITIALIZER;

// --- CODE GENERATION MARKER

// This snippet is generated by /Scripts/sds_codegen/sds_generate.py. Do not manually edit it, instead run `sds_codegen.sh`.

// clang-format off

- (instancetype)initWithGrdbId:(int64_t)grdbId
                      uniqueId:(NSString *)uniqueId
                     dateCreated:(NSDate *)dateCreated
                            info:(StickerPackInfo *)info
                  referenceCount:(NSInteger)referenceCount
NS_DESIGNATED_INITIALIZER NS_SWIFT_NAME(init(grdbId:uniqueId:dateCreated:info:referenceCount:));

// clang-format on

// --- CODE GENERATION MARKER

+ (NSString *)uniqueIdForStickerPackInfo:(StickerPackInfo *)info;

@end

NS_ASSUME_NONNULL_END
